<?xml version="1.0" encoding="UTF-8"?>
<!--
Copyright (C) 2012-2018  Stephan Kreutzer

This file is part of Free Scriptures.

Free Scriptures is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License version 3 or any later version,
as published by the Free Software Foundation.

Free Scriptures is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Affero General Public License 3 for more details.

You should have received a copy of the GNU Affero General Public License 3
along with Free Scriptures. If not, see <http://www.gnu.org/licenses/>.
-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns="http://www.w3.org/1999/xhtml">
  <xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes" doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"/>
  <xsl:template match="XMLBIBLE">
    <html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
      <xsl:comment> This file was generated by haggai2html2.xsl, which is free software licensed under the GNU Affero General Public License 3 or any later version (see https://gitlab.com/free-scriptures/free-scriptures/ and http://www.free-scriptures.org). </xsl:comment>
      <head>
        <title><xsl:value-of select="/XMLBIBLE/@biblename"/></title>
        <meta name="description" content="{/XMLBIBLE/INFORMATION/description}"/>
        <meta name="copyright" content="{/XMLBIBLE/INFORMATION/rights}"/>
        <meta name="author" content="{/XMLBIBLE/INFORMATION/publisher}"/>
        <meta name="generator" content="haggai2html2.xsl (http://www.free-scriptures.org)"/>
        <meta name="keywords" content="{/XMLBIBLE/@biblename}"/>
        <meta http-equiv="expires" content="1296000"/>
        <meta http-equiv="content-type" content="application/xhtml+xml; charset=UTF-8"/>
      </head>
      <body>
        <h1><xsl:value-of select="/XMLBIBLE/@biblename"/></h1>
        <table border="1">
          <tr>
            <th>Meta</th>
            <th>Wert</th>
          </tr>
          <xsl:for-each select="INFORMATION/*">
            <tr>
              <td><xsl:value-of select="local-name()"/></td>
              <td><pre><xsl:value-of select="."/></pre></td>
            </tr>
          </xsl:for-each>
        </table>
        <xsl:apply-templates select="BIBLEBOOK"/>
      </body>
    </html>
  </xsl:template>
  <xsl:template match="BIBLEBOOK">
    <div class="biblebook">
      <xsl:apply-templates select="CHAPTER"/>
    </div>
  </xsl:template>
  <xsl:template match="CHAPTER">
    <div class="chapter">
      <h2>
        <span class="bname">
          <xsl:choose>
            <xsl:when test="../@bname">
              <xsl:value-of select="../@bname"/>
            </xsl:when>
            <xsl:when test="../@bsname">
              <xsl:value-of select="../@bsname"/>
            </xsl:when>
            <xsl:when test="../CAPTION">
              <xsl:value-of select="../CAPTION"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="./@bnumber"/><xsl:text>. Book</xsl:text>
            </xsl:otherwise>
          </xsl:choose>
        </span>
        <xsl:text>&#x20;</xsl:text>
        <span class="cnumber"><xsl:value-of select="@cnumber"/></span>
      </h2>
      <ol>
        <xsl:apply-templates select="VERSE | PARAGRAPH"/>
      </ol>
    </div>
  </xsl:template>
  <xsl:template match="PARAGRAPH">
    <xsl:apply-templates select="VERSE"/>
  </xsl:template>
  <xsl:template match="VERSE">
    <li class="verse">
      <xsl:choose>
        <xsl:when test="local-name(parent::*)='PARAGRAPH'">
          <a name="verse_{../../../@bnumber}_{../../@cnumber}_{@vnumber}" id="verse_{../../../@bnumber}_{../../@cnumber}_{@vnumber}"/>
        </xsl:when>
        <xsl:otherwise>
          <a name="verse_{../../@bnumber}_{../@cnumber}_{@vnumber}" id="verse_{../../@bnumber}_{../@cnumber}_{@vnumber}"/>
        </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates/>
    </li>
  </xsl:template>
  <xsl:template match="VERSE//text()">
    <xsl:value-of select="."/>
  </xsl:template>
  <xsl:template match="STYLE">
    <xsl:choose>
      <xsl:when test="@fs='super'">
        &#x27E8;<xsl:value-of select="."/>&#x27E9;
      </xsl:when>
      <xsl:when test="@fs='emphasis'">
        <b><xsl:value-of select="."/></b>
      </xsl:when>
      <xsl:when test="@fs='italic'">
        <i><xsl:value-of select="."/></i>
      </xsl:when>
    </xsl:choose>
  </xsl:template>
  <xsl:template match="NOTE">
    <abbr title="{.}" lang="de">*</abbr>
  </xsl:template>
</xsl:stylesheet>
